## nco 5.3.2

=== debian/changelog ===
nco (5.3.2-1build1) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 08:00:54 +0000

nco (5.3.2-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 06 Feb 2025 05:34:36 +0100
