=== debian/control ===
Source: nco
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               bison,
               flex,
               antlr,
               libantlr-dev,
               gsl-bin,
               libgsl-dev,
               netcdf-bin,
               libnetcdf-dev,
               libudunits2-dev,
               libdap-dev,
               texinfo
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
Homepage: http://nco.sourceforge.net/
Rules-Requires-Root: no

Package: nco
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command-line operators to analyze netCDF files
 NCO is a suite of programs known as operators. The operators are stand-alone,
 command-line programs executable in a POSIX shell. Operators take one or more
 netCDF files as input, perform operations (e.g., averaging, hyperslabbing),
 and produce a netCDF output file. NCO was originally designed to manipulate and
 analyze climate data, though it works on any netCDF format datasets.
