=== debian/changelog ===
nco (5.3.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update GPL-2+ standalone license paragraph.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 29 Mar 2025 06:28:49 +0100
