=== debian/changelog ===
nco (5.3.4-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 17 Jun 2025 05:31:49 +0200
