=== debian/control ===
--- 
+++ 
@@ -16,9 +16,9 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
-Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git -b experimental
 Homepage: http://nco.sourceforge.net/
 Rules-Requires-Root: no
