## nco 5.3.5

=== debian/changelog ===
nco (5.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 26 Sep 2025 18:46:16 +0200

nco (5.3.4-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Aug 2025 08:03:07 +0200
