## nco 5.3.6

=== bld/Makefile ===
--- 
+++ 
@@ -153,14 +153,14 @@
 ifndef ABI
 # 32- vs. 64-bit ABI: 32=32-bit mode, 64=64-bit mode (default) if available
  ABI := 64
-endif # endif ABI
+endif # !ABI
 ifndef CCACHE
  CCACHE := N
 endif # CCACHE
 ifndef CNK
 # Use newer netCDF4.1 chunking API
  CNK := Y
-endif # endif CNK
+endif # !CNK
 ifndef CUDA
  CUDA := N
 endif # CUDA
@@ -170,27 +170,27 @@
 ifndef DBG
 # Debugging token N=No (default) Y=Yes
  DBG := N
-endif # endif DBG
+endif # !DBG
 ifndef DPKG
 # Debian hardening tokens
  DPKG := N
-endif # endif DPKG
+endif # !DPKG
 ifdef FL_FMT
 # Pass this netCDF4 argument to nco_bm.pl
  FL_FMT_SNG := "--fl_fmt=${FL_FMT}"
-else # endif FL_FMT
+else # !FL_FMT
  FL_FMT_SNG :=
-endif # endif FL_FMT
+endif # !FL_FMT
 ifndef GCC_RCH_ARG
  GCC_RCH_ARG :=
-endif # endif GCC_RCH_ARG
+endif # !GCC_RCH_ARG
 ifndef GSL
 # Use GSL functionality
  GSL := Y
-endif # endif GSL
+endif # !GSL
 ifndef ICC_RCH_ARG
  ICC_RCH_ARG :=
-endif # endif ICC_RCH_ARG
+endif # !ICC_RCH_ARG
 ifndef I18N
  I18N := N
 endif
@@ -200,13 +200,13 @@
 ifndef MK_DPN
  MK_DPN = ${CPP} -M # NB: Recursive expansion required
  MK_DPN_CXX = ${CXX} -M # NB: Recursive expansion required
-endif # endif MK_DPN
+endif # !MK_DPN
 ifndef MPI # MPI
  MPI := N
-endif # endif MPI
+endif # !MPI
 ifndef MPI_FAKE # MPI
  MPI_FAKE := N
-endif # endif MPI_FAKE
+endif # !MPI_FAKE
 ifndef NCO_BUILDENGINE
  NCO_BUILDENGINE := Traditional \(nco/bld/Makefile\)
 endif # NCO_BUILDENGINE
@@ -216,7 +216,7 @@
 endif
 ifndef NETCDF4 # netCDF4 support
  NETCDF4 := Y
-endif # endif NETCDF4
+endif # !NETCDF4
 ifndef NETCDF_ROOT
  NETCDF_ROOT := /usr/local
 endif
@@ -228,21 +228,26 @@
  NETCDF_INC := ${INC_NCAR} # NCAR module path
 else # endelse INC_NCAR
  NETCDF_INC := ${NETCDF_ROOT}/include # Directory containing netcdf.h
-endif # endif INC_NCAR
-endif # endif NETCDF_INC
+endif # !INC_NCAR
+endif # !NETCDF_INC
 ifndef NETCDF_LIB
 ifdef LIB_NCAR
  NETCDF_LIB := ${LIB_NCAR} # NCAR module path
 else # endelse LIB_NCAR
  NETCDF_LIB := ${NETCDF_ROOT}/lib # Directory containing libnetcdf.a
-endif # endif LIB_NCAR
-endif # endif NETCDF_LIB
+endif # !LIB_NCAR
+endif # !NETCDF_LIB
 ifndef ${OMP} # OpenMP
  OMP := N
-endif # endif OMP
+endif # !OMP
 ifndef OPTS
  OPTS := D
 endif
 ifndef PGI_RCH_ARG
  PGI_RCH_ARG :=
-endif # endif PGI_RCH_ARG
+endif # !PGI_RCH_ARG
+ifndef PNETCDF # pnetCDF support
+ PNETCDF := N
+endif # !PNETCDF
+ifndef PSC_RCH_ARG
+ PSC_RCH_ARG :=
