=== debian/changelog ===
nco (5.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 29 Oct 2025 05:42:45 +0100
