=== debian/control ===
--- 
+++ 
@@ -20,7 +20,6 @@
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
 Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
 Homepage: http://nco.sourceforge.net/
-Rules-Requires-Root: no
 
 Package: nco
 Architecture: any
