=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Use custom automake command to prevent autoreconf failure
export AUTOMAKE = ./debian/automake.sh

%:
	dh $@ --buildsystem autoconf

override_dh_auto_configure:
	dh_auto_configure -- \
		--libdir=/usr/lib/nco \
		--disable-nco_cplusplus \
		--disable-static \
		--enable-dap \
		--enable-gsl \
		--enable-ncap2 \
		--enable-netcdf4 \
		--enable-udunits2

execute_after_dh_auto_build:
	cd doc && $(MAKE) clean && $(MAKE) html
	cd doc && $(MAKE) nco.info && sed -i 's/xmp\/fgr[0-9].png/\/usr\/share\/doc\/nco\/&/' nco.info*

override_dh_auto_test:
	# currently the check phase badly fails
	dh_auto_test || echo "Ignoring test failures"

execute_after_dh_auto_install:
	find $(CURDIR)/debian/nco -name '*.h' -delete
	find $(CURDIR)/debian/nco -name '*.hh' -delete
	$(RM) debian/nco/usr/lib/nco/libnco.la
	$(RM) debian/nco/usr/share/info/dir

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/nco
